<template>
  <div>
    <AppWindow
        v-bind:show="show"
        title="Add new circle"
        cancelable
        @canceled="() => this.$emit('canceled')"
        width="700"
        @submitted="addBtnClick"
        :disabled-submit="!validForm"
    >
      <br>
      <v-form v-model="validForm">
        <v-row>
          <v-col>
            <v-text-field
                label="Center X"
                v-model="tempCircle.center_x"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Center Y"
                v-model="tempCircle.center_y"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Radius"
                v-model="tempCircle.radius"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
        </v-row>
      </v-form>

      <template v-slot:submit-text>
        Add
      </template>
    </AppWindow>
  </div>
</template>

<script>
import AppWindow from './../AppWindow/AppWindow'
import {AppContext} from '@Util'

const defaultCircle = {
  center_x: '0',
  center_y: '0',
  radius: '1e-8'
}

export default {
  name: 'AddCircle',
  components: {
    AppWindow
  },
  props: {
    show: Boolean
  },
  data: () => ({
    tempCircle: defaultCircle,
    isNumber: val => !isNaN(Number(val)) || `${val} is not a valid number`,
    notNul: val => val !== '0' || 'Must be different from 0',
    notEmpty: val => val !== '' || `Can't be empty`,
    validForm: false,
  }),
  watch: {
    show(val) {
      this.tempCircle = JSON.parse(JSON.stringify(defaultCircle))
      Object.assign(AppContext, {mode: val ? 0 : 2})
    }
  },
  methods: {
    addBtnClick() {
      AppContext.currentProject.AddCircle({
        info: {
          center_x: Number(this.tempCircle.center_x),
          center_y: Number(this.tempCircle.center_y),
          radius: Number(this.tempCircle.radius)
        }
      })
      AppContext.currentProject.Save()
      this.$emit('saved')
    }
  }
}
</script>